using GLib;

public class Configuration : Object {
    public signal void tracks_username_changed ();
    public signal void tracks_password_changed ();
    public signal void tracks_uri_changed ();
	public static Gee.ArrayList<NoteWindow> openNoteWindows;
	public static Gee.ArrayList<TaskWindow> openTaskWindows;

    private string _tracks_username;
    public string tracks_username  { 
        get {
            return _tracks_username;
        }
        set {
        _tracks_username = value;
        } 
    }

    private string _tracks_password;
    public string tracks_password  { 
        get {
            return _tracks_password;
        } 
        set {
        _tracks_password = value;
        } 
    }
    
    private string _tracks_uri;
    public string tracks_uri  { 
        get {
            return _tracks_uri;
        }
        set {
        _tracks_uri = value;
        } 
    }
 
    private int _view;
    public int view  { 
        get {
            return _view;
        }
        set {
	        _view = value;
        } 
    }
 
	private IBackend backend;
	private Logger log;  

    construct {
        tracks_username = "";
        tracks_password = "";
        tracks_uri = "" ;
		view = 0;
		log = Logger.getLogger("Configuration");
		openNoteWindows = new Gee.ArrayList<NoteWindow>();
		openTaskWindows = new Gee.ArrayList<TaskWindow>();

    }
    
    public Configuration (IBackend aBackend) {
		backend = aBackend;
        backend.uri = tracks_uri;
   }

	public void initOpenedWindows() {
		/* init list of opened Note windows */
		string openedNotes = backend.getConfig("openedNotes");
		string[] openedNotesList = openedNotes.split(" ");
		foreach (string noteID in openedNotesList) {
			foreach (INote note in backend.notes) {
				if (note.id == noteID) {
					Utils.UI.showNoteWindow(note);
				}
			}
		}

		/* init list of opened Task windows */
		string openedTasks = backend.getConfig("openedTasks");
		string[] openedTasksList = openedTasks.split(" ");
		foreach (string taskID in openedTasksList) {
			foreach (ITask task in backend.tasks) {
				if (task.id == taskID) {
					Utils.UI.showTaskWindow(task);
				}
			}
		}
	}

	/* write persistent configuration to db */
	public void sync() {
		/* get a list of all opened note windows */
		string openedNotes = "";
		foreach (NoteWindow win in openNoteWindows) {
			openedNotes += win.id + " ";
		}
		backend.updateConfig( "openedNotes" , openedNotes);

		string openedTasks = "";
		foreach (TaskWindow win in openTaskWindows) {
			openedTasks += win.id + " ";
		}
		backend.updateConfig( "openedTasks" , openedTasks);

	}

}
