public interface IItem : GLib.Object {
    /* properties */
    public abstract string id { get; set; }
    public abstract string name { get; set; }
    public abstract string text { get; set; }

    public abstract int width {get; set;}
    public abstract int height {get; set;}

	/* Constant.itemType */
    public abstract int instanceOf { get; }

    public abstract GLib.Time createdAt { get; set; }
    public abstract GLib.Time updatedAt { get; set; }


    public abstract bool isDeleted {get; set;}
    //public abstract IBackend backend  { get; set;}

    /*signals*/
    public abstract signal void created ( bool status );
    public abstract signal void deleted ( bool status );
    public abstract signal void updated ( bool status );

	/* methods */
    public abstract void push ();
    public abstract void delete ();
    public abstract void update ();

}
