public class Logger : GLib.Object {

	private string domain;

	construct {
		domain = "";
	}

	public Logger(string? logDomain) {
		if (logDomain != null) domain = logDomain;
	}

	public static Logger getLogger(string? logDomain) {
		return new Logger(logDomain);
	}
	
	public void debug (string txt) {
		GLib.Time now = GLib.Time.gm(time_t());
		stdout.printf("DEBUG " + now.to_string() + " :" + domain + ": " + txt + "\n");
		stdout.flush();
	}

	public void error (string txt) {
		GLib.Time now = GLib.Time.gm(time_t());
		stdout.printf("ERROR " + now.to_string() + " :" + domain + ": " + txt + "\n");
		stdout.flush();
	}

	public void info (string txt) {
		GLib.Time now = GLib.Time.gm(time_t());
		stdout.printf("INFO " + now.to_string() + " :" + domain + ": " + txt + "\n");
		stdout.flush();
	}

	public void warn (string txt) {
		GLib.Time now = GLib.Time.gm(time_t());
		stdout.printf("WARN " + now.to_string() + " :" + domain + ": " + txt + "\n");
		stdout.flush();
	}

	public void fatal (string txt) {
		GLib.Time now = GLib.Time.gm(time_t());
		stdout.printf("FATAL " + now.to_string() + " :" + domain + ": " + txt + "\n");
		stdout.flush();
	}

	public void trace (string txt) {
		GLib.Time now = GLib.Time.gm(time_t());
		stdout.printf("TRACE " + now.to_string() + " :" + domain + ": " + txt + "\n");
		stdout.flush();
	}

}
