using GLib;
public static class LucruriGTKApplication : GLib.Object {
	private MainWindow mainWindow;
	public Configuration config;
	public LucruriGTKApplication () {
        GLib.TimeVal start_time = GLib.TimeVal();
        IBackend backend = new CouchDBBackend();
        config = new Configuration(backend);
        mainWindow = new MainWindow ( backend , config );
		mainWindow.update();
        mainWindow.destroy += Gtk.main_quit;
        GLib.TimeVal end_time = GLib.TimeVal();
        stdout.printf("Startup time: %f seconds\n",
            (float)(end_time.tv_usec - start_time.tv_usec)/1000000);
        mainWindow.show_all ();
	}

    static int main (string[] args) {
        // this is a workaround to make Vala include config.h before
        // gi18n-lib.h
        string gettext_package = Config.GETTEXT_PACKAGE;

        Intl.bindtextdomain(gettext_package, Config.PACKAGE_LOCALEDIR);
        Intl.bind_textdomain_codeset(Config.GETTEXT_PACKAGE, "UTF-8");
        Intl.textdomain(Config.GETTEXT_PACKAGE);
       	Gtk.init (ref args);

		var app = new LucruriGTKApplication();
        Gtk.main ();
		app.config.sync();
        return 0;
    }
	     
}
