using Gtk;
public class NotesTreeView : Gtk.TreeView {

	public NotesTreeView () {
		get_selection().set_mode(Gtk.SelectionMode.BROWSE);

		rules_hint = true;
		headers_visible = true;
		hover_selection = true;

        TreeViewColumn column;

		//
		// Note Name Column
		//
		column = new Gtk.TreeViewColumn ();
		// Title for Column
		column.title = "Note";
		column.sizing = Gtk.TreeViewColumnSizing.AUTOSIZE;
		column.expand = true;
		column.resizable = false;

		Gtk.CellRendererPixbuf editRenderer = new Gtk.CellRendererPixbuf ();
		column.pack_start (editRenderer, false);
		column.set_cell_data_func (
			editRenderer,
			(cell_layout, cell, model, iter) =>	{
				Gtk.CellRendererPixbuf crp = cell as Gtk.CellRendererPixbuf;
        		crp.pixbuf = Utils.UI.getPixbuf ("/icons/16x16/places/note.png" );


    		}
			);

		Gtk.CellRendererText nameRenderer = new Gtk.CellRendererText ();
		column.pack_start (nameRenderer, true);
		column.set_cell_data_func (
			nameRenderer,
			(cell_layout, cell, model, iter) =>	{
				Gtk.CellRendererText crt = cell as Gtk.CellRendererText;
				crt.ellipsize = Pango.EllipsizeMode.END;

        		INote note = null;
				model.get (iter, 0, out note);
				if (note == null) {
				    return;
				}
				crt.text = note.name;
    		}
			);
		nameRenderer.editable = false;
		
		append_column (column);


		//
		// Note UpdatedAt Column
		//
		column = new Gtk.TreeViewColumn ();
		// Title for Column
		column.title = "Last Changed";
		column.sizing = Gtk.TreeViewColumnSizing.FIXED;
		column.sizing = Gtk.TreeViewColumnSizing.AUTOSIZE;
		column.expand = true;
		column.resizable = true;
		
		Gtk.CellRendererText updateAtRenderer = new Gtk.CellRendererText ();
		column.pack_start (updateAtRenderer, true);
		updateAtRenderer.editable = false;
		column.set_cell_data_func 
			(updateAtRenderer,
			(cell_layout, cell, model, iter) =>	{
				Gtk.CellRendererText crt = cell as Gtk.CellRendererText;
				crt.ellipsize = Pango.EllipsizeMode.END;

	    		INote note;
				model.get (iter, 0, out note);
				if (note.backend != null)
					crt.text = note.updatedAt.to_string();
    		}
			);

		append_column (column);

	}

	public override void row_activated (Gtk.TreePath path, Gtk.TreeViewColumn column) {
            Gtk.TreeIter iter;
            INote note;
            if (!this.model.get_iter (out iter, path))  return; // Do nothing
		    this.model.get (iter, 0, out note);	
            if ( note == null ) return;	 // if error .. do nothing
            Utils.UI.showNoteWindow(note);
	}

}
