
public class PreferencesDialog : Gtk.Dialog {
   
    private Configuration preferences;

    public PreferencesDialog ( Configuration somePreferences ) {
        
        preferences = somePreferences;
        
        this.add_button( Gtk.STOCK_CLOSE, Gtk.ResponseType.OK );
        this.modal = true;
        
        //title of the preferences window
        this.title = _("Configuration Lucruri");
        this.icon = Utils.UI.getPixbuf("/icons/16x16/emotes/face-monkey.png");

        // Create a table with 4 rows and 2 column
        Gtk.Table tableLayout = new Gtk.Table(4, 2, false);
        Gtk.Label text = new Gtk.Label(_("Enter configuration info below:"));

        // Attach the label over the entire first row
        tableLayout.attach_defaults ( text,   0, 2, 0, 1);
        
        text = new Gtk.Label(_("Username:"));
        Gtk.Entry usernameEntry = new Gtk.Entry();
        usernameEntry.focus_out_event += ( obj, event ) => {
            preferences.tracks_username = obj.get_text();
        };
        usernameEntry.set_text(preferences.tracks_username);
        tableLayout.attach_defaults (text, 0, 1, 1, 2);
        tableLayout.attach_defaults (usernameEntry, 1, 2, 1, 2);

        text = new Gtk.Label(_("Password:"));
        Gtk.Entry passwordEntry = new Gtk.Entry();
        passwordEntry.focus_out_event += ( obj, event ) => {
            preferences.tracks_password = obj.get_text();
        };

        passwordEntry.set_text(preferences.tracks_password);
        passwordEntry.set_visibility (false);
        tableLayout.attach_defaults (text, 0, 1, 2, 3);
        tableLayout.attach_defaults (passwordEntry, 1, 2, 2, 3);

        text = new Gtk.Label(_("Web Address:"));
        Gtk.Entry uriEntry = new Gtk.Entry();
        uriEntry.focus_out_event += ( obj, event ) => {
            preferences.tracks_uri = obj.get_text();
        };

        uriEntry.set_text(preferences.tracks_uri);
        tableLayout.attach_defaults (text, 0, 1, 3, 4);
        tableLayout.attach_defaults (uriEntry, 1, 2, 3, 4);

        tableLayout.show_all();
        this.vbox.pack_start (tableLayout, true, true, 0);
    }
}
