public class TomboyBackend : GLib.Object , INotesBackend {
    /* properties */
    public Gee.ArrayList<INote> notes { set; get; }

   /* signals */
    public signal void notesRefreshed ();

   /*methods*/
    public void refreshNotes () {
        doRefreshNotes();
    }

    public void createNote ( string name, string text ) {
        doCreateNote ( name, text );
    }
    public void deleteNode ( INote note ) {
        doDeleteNode ( note );
    }

    public void updateNote ( INote note ) {
        doUpdateNote ( note );
    }


/*******************************************************************************
 * Private stuff 
 */
    construct {
        notes = new Gee.ArrayList<INote>();
    }

    private void doRefreshNotes() {
        try {
            GLib.Dir dir = GLib.Dir.open("/home/adi/.tomboy/",0);
            string fileName;
            TomboyNote note;
            while (( fileName = dir.read_name() ) != null ) {
                if (GLib.FileUtils.test ("/home/adi/.tomboy/"+ fileName, GLib.FileTest.IS_REGULAR) && fileName.has_suffix(".note")) {
                string xml;
                ulong len;
 stdout.flush();
                FileUtils.get_contents ("/home/adi/.tomboy/"+ fileName, out xml, out len);
                xml = xml.substring(1, xml.length -1);
                //stdout.printf("conte for %s\n|%s|\n","/home/adi/.tomboy/"+ fileName, xml);
                note = new TomboyNote.fromXML(xml);
                this.notes.add(note);
                }
            }
            notesRefreshed();
        } catch (GLib.Error e) {
            stdout.printf("%s\n",e.message);
        }
    }

    public void doCreateNote ( string name, string text ) {

    }
    public void doDeleteNode ( INote note ) {

    }

    public void doUpdateNote ( INote note ) {

    }
    
}
