using Sqlite;

void testUpdateNotes () {

		Database db;
		string db_uri = "/home/adi/.lucruri/lucruri.db3";
		assert(FileUtils.test (db_uri, FileTest.IS_REGULAR));
		int rc = Database.open (db_uri, out db);
		assert( rc == Sqlite.OK);

		for (int i = 0; i< 1000; i++) {
			string query = "UPDATE notes SET ";
			query += "name = 'caca maca' , ";
			query += " WHERE id='32';";
			db.exec(query);
			
		}

}

void testTableProjects () {
		Database db;
		string db_uri = "/home/adi/.lucruri/lucruri.db3";
		assert(FileUtils.test (db_uri, FileTest.IS_REGULAR));
		int rc = Database.open (db_uri, out db);
		assert( rc == Sqlite.OK);

		string query = "SELECT * FROM projects;";
		weak string[] result;
		string errmsg;
		int rowNumber;
		int columnNumber;
		db.get_table (query, out result, out rowNumber, out columnNumber, out errmsg);

		assert (rowNumber > 0 );
		assert (columnNumber == 8);
		HashTable<string,int> column = new HashTable<string,int>(GLib.str_hash, GLib.str_equal);
		for (int i = 0; i < columnNumber; i++) {
			column.insert(result[i],i);
		}
		for (int i = columnNumber; i < (rowNumber * columnNumber) ; i += columnNumber) {
		}
		db.free_table(result);
}

void main (string[] args)
{
       // this is a workaround to make Vala include config.h before
        // gi18n-lib.h
        string gettext_package = Config.GETTEXT_PACKAGE;
        Intl.bindtextdomain(gettext_package, Config.PACKAGE_LOCALEDIR);
        Intl.bind_textdomain_codeset(Config.GETTEXT_PACKAGE, "UTF-8");
        Intl.textdomain(Config.GETTEXT_PACKAGE);



  Test.init(ref args);
  Test.add_func("/SQLite/Table/Projects",testTableProjects);
  Test.add_func("/SQLite/Update/Notes",testUpdateNotes);
  Test.run ();
}
