/*
Migrate from sqlite to desktopcouch

You should not use this tools, unless you start using Lucruri in production

This is a pretty crude code.

valac --vapidir ../vapi/ \
    --pkg sqlite3 --pkg couchdb-glib-1.0 --pkg desktopcouch-glib-1.0 \
    --thread -o migrate MigrateSqliteToDesktopCouch.vala
*/
using Sqlite;
using CouchDB;

public static class Migrate : GLib.Object {

    static int main (string[] args) {
	    Database db;
		weak string[] result;
		string errmsg;
		string query;
		int rowNumber;
		int columnNumber;
        HashTable<string,int> columnIndex;
        Document doc;
        Connection couch;
        HashTable<string,string> projects_id = new HashTable<string,string>(GLib.str_hash, GLib.str_equal);
        HashTable<string,string> categories_id = new HashTable<string,string>(GLib.str_hash, GLib.str_equal);

        Database.open ("/home/adi/.lucruri/lucruri.db3", out db);        
        couch = new DesktopCouch.Connection() as CouchDB.Connection;

		query = "SELECT * FROM projects ORDER BY position ASC;";
		db.get_table (query, out result, out rowNumber, out columnNumber, out errmsg);
		columnIndex = new HashTable<string,int>(GLib.str_hash, GLib.str_equal);

		for (int i = 0; i < columnNumber; i++)
			columnIndex.insert(result[i],i);
		for (int i = columnNumber; i < ((rowNumber+1) * columnNumber) ; i += columnNumber) {
			string[] rows = new string[columnNumber];
			for (int j=0; j < columnNumber; j++) rows[j] = result[i+j];

            doc = new Document(couch);
            doc.set_string_field(
                "title", rows[columnIndex.lookup("name")]);
            doc.set_string_field(
                "content", rows[columnIndex.lookup("text")]);
            doc.set_int_field(
                "position", rows[columnIndex.lookup("position")].to_int());
            doc.set_string_field(
                "created_date", rows[columnIndex.lookup("created_at")].replace(" ","T"));
            doc.set_string_field(
                "record_type",
		        "http://launchpad.net/lucruri/project");
            doc.set_string_field(
                "record_type_version",
		        "1.0");
            doc.put("lucruri");
            projects_id.insert(rows[columnIndex.lookup("id")],doc.get_id());
        }

		query = "SELECT * FROM categories ORDER BY position ASC;";
		db.get_table (query, out result, out rowNumber, out columnNumber, out errmsg);
		columnIndex = new HashTable<string,int>(GLib.str_hash, GLib.str_equal);

		for (int i = 0; i < columnNumber; i++)
			columnIndex.insert(result[i],i);
		for (int i = columnNumber; i < ((rowNumber+1) * columnNumber) ; i += columnNumber) {
			string[] rows = new string[columnNumber];
			for (int j=0; j < columnNumber; j++) rows[j] = result[i+j];

            doc = new Document(couch);
            doc.set_string_field(
                "title", rows[columnIndex.lookup("name")]);
            doc.set_string_field(
                "content", rows[columnIndex.lookup("text")]);
            doc.set_int_field(
                "position", rows[columnIndex.lookup("position")].to_int());
            doc.set_boolean_field(
                "hide", (rows[columnIndex.lookup("hide")] == "1") ? true: false);
            doc.set_string_field(
                "created_date", rows[columnIndex.lookup("created_at")].replace(" ","T"));
            doc.set_string_field(
                "record_type",
		        "http://launchpad.net/lucruri/category");
            doc.set_string_field(
                "record_type_version",
		        "1.0");
            doc.put("lucruri");
            categories_id.insert(rows[columnIndex.lookup("id")],doc.get_id());
        }


		query = "SELECT * FROM notes;";
		db.get_table (query, out result, out rowNumber, out columnNumber, out errmsg);
		columnIndex = new HashTable<string,int>(GLib.str_hash, GLib.str_equal);

		for (int i = 0; i < columnNumber; i++)
			columnIndex.insert(result[i],i);
		for (int i = columnNumber; i < ((rowNumber+1) * columnNumber) ; i += columnNumber) {
			string[] rows = new string[columnNumber];
			for (int j=0; j < columnNumber; j++) rows[j] = result[i+j];


            doc = new Document(couch);

            CouchDB.StructField application_annotations;
            application_annotations = new CouchDB.StructField();
            doc.set_application_annotations(application_annotations);
            CouchDB.StructField lucruri_annotations;
            lucruri_annotations = new CouchDB.StructField();
            application_annotations.set_struct_field(
                "Lucruri",
                lucruri_annotations);
            lucruri_annotations.set_boolean_field(
                "sticky", (rows[columnIndex.lookup("sticky")] == "1") ? true: false);
            lucruri_annotations.set_string_field(
               "project-id",
                projects_id.lookup(rows[columnIndex.lookup("project_id")]));

            doc.set_string_field(
                "title", rows[columnIndex.lookup("name")]);
            doc.set_string_field(
                "content", rows[columnIndex.lookup("text")]);
            doc.set_string_field(
                "project-id",
                projects_id.lookup(rows[columnIndex.lookup("project_id")]));
            doc.set_string_field(
                "created_date", rows[columnIndex.lookup("created_at")].replace(" ","T"));
            doc.set_string_field(
                "last_change_date", rows[columnIndex.lookup("updated_at")].replace(" ","T"));
            doc.set_string_field(
                "record_type",
		        "http://www.freedesktop.org/wiki/Specifications/desktopcouch/note");
            doc.set_string_field(
                "record_type_version",
		        "1.0");
            doc.put("notes");
        }

		query = "SELECT * FROM tasks;";
		db.get_table (query, out result, out rowNumber, out columnNumber, out errmsg);
		columnIndex = new HashTable<string,int>(GLib.str_hash, GLib.str_equal);

		for (int i = 0; i < columnNumber; i++)
			columnIndex.insert(result[i],i);
		for (int i = columnNumber; i < ((rowNumber+1) * columnNumber) ; i += columnNumber) {
			string[] rows = new string[columnNumber];
			for (int j=0; j < columnNumber; j++) rows[j] = result[i+j];


            doc = new Document(couch);

            CouchDB.StructField application_annotations;
            application_annotations = new CouchDB.StructField();
            doc.set_application_annotations(application_annotations);
            CouchDB.StructField lucruri_annotations;
            lucruri_annotations = new CouchDB.StructField();
            application_annotations.set_struct_field(
                "Lucruri",
                lucruri_annotations);
            lucruri_annotations.set_string_field(
               "project-id",
                projects_id.lookup(rows[columnIndex.lookup("project_id")]));
            lucruri_annotations.set_string_field(
               "category-id",
                categories_id.lookup(rows[columnIndex.lookup("category_id")]));

            doc.set_string_field(
                "title", rows[columnIndex.lookup("name")]);
            doc.set_string_field(
                "content", rows[columnIndex.lookup("text")]);
            doc.set_string_field(
                "created_date", rows[columnIndex.lookup("created_at")].replace(" ","T"));
            doc.set_string_field(
                "last_change_date", rows[columnIndex.lookup("updated_at")].replace(" ","T"));
            doc.set_string_field(
                "due_date", rows[columnIndex.lookup("due_at")].replace(" ","T"));
            doc.set_string_field(
                "show_from_date", rows[columnIndex.lookup("show_from")].replace(" ","T"));
            doc.set_string_field(
                "completed_date", rows[columnIndex.lookup("completed_at")].replace(" ","T"));
            doc.set_boolean_field(
                "done", (rows[columnIndex.lookup("done")] == "1") ? true: false);
            doc.set_string_field(
                "record_type",
		        "http://www.freedesktop.org/wiki/Specifications/desktopcouch/task");
            doc.set_string_field(
                "record_type_version",
		        "1.0");
            doc.put("tasks");
        }

        return 0;
    }

}
