<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

function result_from_xml( $xml)
{
    $out = array();
    $CI = &get_instance();
    $parser = xml_parser_create();
    xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
    xml_parse_into_struct($parser, $xml, $values, $tags);
    xml_parser_free($parser);
    // loop through the structures
    foreach ($tags as $key=>$val) {
        if ($key == $values[0]['tag']) {
            // each contiguous pair of array entries are the 
            // lower and upper range for each definition
            for ($i=0; $i < count($val); $i+=2) {
                $offset = $val[$i] + 1;
                $len = $val[$i + 1] - $offset;
                $raw = array_slice($values, $offset, $len);
		foreach ($raw as $item) {
		    $item['tag'] = str_replace('-','_',$item['tag']);
		    if (in_array($item['tag'],$CI->config->item('datetime_fields')) &&
			isset($item['value'])) {
			$item['value'] = standard_to_unix('DATE_W3C',$item['value']);
		    }
		    $out[$item['tag']] = $item['value'];
		}
            }
        } else {
            continue;
        }
    }
    return $out;
}

function array_from_xml( $xml)
{
    $out = array();
    $CI = &get_instance();
    $parser = xml_parser_create();
    xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
    xml_parse_into_struct($parser, $xml, $values, $tags);
    xml_parser_free($parser);
    // loop through the structures
    array_shift($tags);
    foreach ($tags as $tag) {
        $key = $values[$tag[0]]['tag'];
	$value = isset($values[$tag[0]]['value']) ? $values[$tag[0]]['value'] : "";
	$key = str_replace('-','_',$key);
	
        if (in_array($key,$CI->config->item('datetime_fields')) &&
	    $value) {
	    $value = standard_to_unix('DATE_W3C',$value);
	}
	$out[$key] = $value;
    }
    return $out;
}


function result_dbdatetime_to_unix ($result)
{
    $out = $result;
    $CI = & get_instance();
    foreach ($out as $rkey => $rvalue) {
        foreach ($out[$rkey] as $key => $value ){
            if (in_array($key, $CI->config->item('datetime_fields')) &&
		$value) { 
                $out[$rkey][$key] = mysql_to_unix($value);
            }
        }
    }
    return $out;
}

function array_unix_to_dbdatetime ($result)
{
    $out = $result;
    $CI = & get_instance();
        foreach ($out as $key => $value ){
            if (in_array($key, $CI->config->item('datetime_fields')) &&
		is_numeric($value)) { 
                $out[$key] = unix_to_dbdatetime($value);
            }
        }
    return $out;
}


function array_get_request ()
{
    $input = file_get_contents('php://input');
    $data = array_from_xml($input);
    $data = array_unix_to_dbdatetime($data);
    return $data;			
}

function array_filter_result( $data )
{
    $out = array();
    foreach ($data as $key => $value) {
	if (!is_numeric($key)) $out[$key]=$value;
    }
    return $out;
}
/* End of file MY_array_helper.php */
